
module MenhirBasics = struct
  
  exception Error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | RBRACK
    | PIPE
    | LBRACK
    | ID of (
# 7 "src/bnf_parser.mly"
       (string)
# 18 "src/bnf_parser.ml"
  )
    | EOF
    | DOT
    | DEF
  
end

include MenhirBasics

# 1 "src/bnf_parser.mly"
  
open Bnf_spec.Bnf
open Spec

# 33 "src/bnf_parser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState00 : ('s, _menhir_box_start) _menhir_state
    (** State 00.
        Stack shape : .
        Start symbol: start. *)

  | MenhirState07 : (('s, _menhir_box_start) _menhir_cell1_nt, _menhir_box_start) _menhir_state
    (** State 07.
        Stack shape : nt.
        Start symbol: start. *)

  | MenhirState11 : ((('s, _menhir_box_start) _menhir_cell1_nt, _menhir_box_start) _menhir_cell1_prods, _menhir_box_start) _menhir_state
    (** State 11.
        Stack shape : nt prods.
        Start symbol: start. *)

  | MenhirState12 : (((('s, _menhir_box_start) _menhir_cell1_nt, _menhir_box_start) _menhir_cell1_prods, _menhir_box_start) _menhir_cell1_prod, _menhir_box_start) _menhir_state
    (** State 12.
        Stack shape : nt prods prod.
        Start symbol: start. *)

  | MenhirState16 : ((('s, _menhir_box_start) _menhir_cell1_nt, _menhir_box_start) _menhir_cell1_prod, _menhir_box_start) _menhir_state
    (** State 16.
        Stack shape : nt prod.
        Start symbol: start. *)

  | MenhirState17 : (('s, _menhir_box_start) _menhir_cell1_defs, _menhir_box_start) _menhir_state
    (** State 17.
        Stack shape : defs.
        Start symbol: start. *)


and ('s, 'r) _menhir_cell1_defs = 
  | MenhirCell1_defs of 's * ('s, 'r) _menhir_state * (Bnf_spec.Bnf.grammar)

and ('s, 'r) _menhir_cell1_nt = 
  | MenhirCell1_nt of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_prod = 
  | MenhirCell1_prod of 's * ('s, 'r) _menhir_state * (Bnf_spec.Spec.symbol list)

and ('s, 'r) _menhir_cell1_prods = 
  | MenhirCell1_prods of 's * ('s, 'r) _menhir_state * (Bnf_spec.Spec.symbol list list)

and _menhir_box_start = 
  | MenhirBox_start of (Bnf_spec.Bnf.grammar) [@@unboxed]

let _menhir_action_01 =
  fun _1 _3 ->
    (
# 22 "src/bnf_parser.mly"
                       ( List.fold_left (fun a -> add_prod a _1 ()) empty _3 )
# 87 "src/bnf_parser.ml"
     : (Bnf_spec.Bnf.grammar))

let _menhir_action_02 =
  fun _1 ->
    (
# 19 "src/bnf_parser.mly"
        ( _1 )
# 95 "src/bnf_parser.ml"
     : (Bnf_spec.Bnf.grammar))

let _menhir_action_03 =
  fun _1 _2 ->
    (
# 20 "src/bnf_parser.mly"
             ( union _1 _2 )
# 103 "src/bnf_parser.ml"
     : (Bnf_spec.Bnf.grammar))

let _menhir_action_04 =
  fun _2 ->
    (
# 36 "src/bnf_parser.mly"
                      ( _2 )
# 111 "src/bnf_parser.ml"
     : (string))

let _menhir_action_05 =
  fun _1 ->
    (
# 29 "src/bnf_parser.mly"
           ( [_1] )
# 119 "src/bnf_parser.ml"
     : (Bnf_spec.Spec.symbol list))

let _menhir_action_06 =
  fun _1 _2 ->
    (
# 30 "src/bnf_parser.mly"
                ( _2 :: _1 )
# 127 "src/bnf_parser.ml"
     : (Bnf_spec.Spec.symbol list))

let _menhir_action_07 =
  fun _1 ->
    (
# 25 "src/bnf_parser.mly"
         ( [List.rev _1] )
# 135 "src/bnf_parser.ml"
     : (Bnf_spec.Spec.symbol list list))

let _menhir_action_08 =
  fun _1 _3 ->
    (
# 26 "src/bnf_parser.mly"
                    ( (List.rev _3) :: _1 )
# 143 "src/bnf_parser.ml"
     : (Bnf_spec.Spec.symbol list list))

let _menhir_action_09 =
  fun () ->
    (
# 15 "src/bnf_parser.mly"
        ( empty )
# 151 "src/bnf_parser.ml"
     : (Bnf_spec.Bnf.grammar))

let _menhir_action_10 =
  fun _1 ->
    (
# 16 "src/bnf_parser.mly"
             ( _1 )
# 159 "src/bnf_parser.ml"
     : (Bnf_spec.Bnf.grammar))

let _menhir_action_11 =
  fun _1 ->
    (
# 33 "src/bnf_parser.mly"
       ( T _1 )
# 167 "src/bnf_parser.ml"
     : (Bnf_spec.Spec.symbol))

let _menhir_action_12 =
  fun _1 ->
    (
# 34 "src/bnf_parser.mly"
       ( NT _1 )
# 175 "src/bnf_parser.ml"
     : (Bnf_spec.Spec.symbol))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | DEF ->
        "DEF"
    | DOT ->
        "DOT"
    | EOF ->
        "EOF"
    | ID _ ->
        "ID"
    | LBRACK ->
        "LBRACK"
    | PIPE ->
        "PIPE"
    | RBRACK ->
        "RBRACK"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37-39"]
  
  let rec _menhir_run_01 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_start) _menhir_state -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RBRACK ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _2 = _v in
              let _v = _menhir_action_04 _2 in
              _menhir_goto_nt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_nt : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_start) _menhir_state -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState07 ->
          _menhir_run_14_spec_07 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState16 ->
          _menhir_run_14_spec_16 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState11 ->
          _menhir_run_14_spec_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState12 ->
          _menhir_run_14_spec_12 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState17 ->
          _menhir_run_06 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState00 ->
          _menhir_run_06 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_14_spec_07 : type  ttv_stack. (ttv_stack, _menhir_box_start) _menhir_cell1_nt -> _ -> _ -> _ -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_12 _1 in
      _menhir_run_09_spec_07 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_09_spec_07 : type  ttv_stack. (ttv_stack, _menhir_box_start) _menhir_cell1_nt -> _ -> _ -> _ -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_05 _1 in
      _menhir_run_16 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState07 _tok
  
  and _menhir_run_16 : type  ttv_stack. ((ttv_stack, _menhir_box_start) _menhir_cell1_nt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_start) _menhir_state -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LBRACK ->
          let _menhir_stack = MenhirCell1_prod (_menhir_stack, _menhir_s, _v) in
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState16
      | ID _v_0 ->
          let _menhir_stack = MenhirCell1_prod (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v_0 in
          let _v = _menhir_action_11 _1 in
          _menhir_run_13 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | DOT | PIPE ->
          let _1 = _v in
          let _v = _menhir_action_07 _1 in
          _menhir_goto_prods _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_13 : type  ttv_stack. (ttv_stack, _menhir_box_start) _menhir_cell1_prod -> _ -> _ -> _ -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_prod (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_06 _1 _2 in
      _menhir_goto_prod _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_prod : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_start) _menhir_state -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState07 ->
          _menhir_run_16 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState11 ->
          _menhir_run_12 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_12 : type  ttv_stack. (((ttv_stack, _menhir_box_start) _menhir_cell1_nt, _menhir_box_start) _menhir_cell1_prods as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_start) _menhir_state -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LBRACK ->
          let _menhir_stack = MenhirCell1_prod (_menhir_stack, _menhir_s, _v) in
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState12
      | ID _v_0 ->
          let _menhir_stack = MenhirCell1_prod (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v_0 in
          let _v = _menhir_action_11 _1 in
          _menhir_run_13 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | DOT | PIPE ->
          let MenhirCell1_prods (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_08 _1 _3 in
          _menhir_goto_prods _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_prods : type  ttv_stack. ((ttv_stack, _menhir_box_start) _menhir_cell1_nt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_start) _menhir_state -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_prods (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LBRACK ->
              _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState11
          | ID _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_0 in
              let _v = _menhir_action_11 _1 in
              _menhir_run_09_spec_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              _eRR ())
      | DOT ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_nt (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_01 _1 _3 in
          _menhir_goto_def _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_09_spec_11 : type  ttv_stack. ((ttv_stack, _menhir_box_start) _menhir_cell1_nt, _menhir_box_start) _menhir_cell1_prods -> _ -> _ -> _ -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_05 _1 in
      _menhir_run_12 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState11 _tok
  
  and _menhir_goto_def : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_start) _menhir_state -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState00 ->
          _menhir_run_20_spec_00 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState17 ->
          _menhir_run_19 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_20_spec_00 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_02 _1 in
      _menhir_run_17 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState00 _tok
  
  and _menhir_run_17 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_start) _menhir_state -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LBRACK ->
          let _menhir_stack = MenhirCell1_defs (_menhir_stack, _menhir_s, _v) in
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState17
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_10 _1 in
          MenhirBox_start _v
      | _ ->
          _eRR ()
  
  and _menhir_run_19 : type  ttv_stack. (ttv_stack, _menhir_box_start) _menhir_cell1_defs -> _ -> _ -> _ -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_defs (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_03 _1 _2 in
      _menhir_run_17 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_14_spec_16 : type  ttv_stack. ((ttv_stack, _menhir_box_start) _menhir_cell1_nt, _menhir_box_start) _menhir_cell1_prod -> _ -> _ -> _ -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_12 _1 in
      _menhir_run_13 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_14_spec_11 : type  ttv_stack. ((ttv_stack, _menhir_box_start) _menhir_cell1_nt, _menhir_box_start) _menhir_cell1_prods -> _ -> _ -> _ -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_12 _1 in
      _menhir_run_09_spec_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_14_spec_12 : type  ttv_stack. (((ttv_stack, _menhir_box_start) _menhir_cell1_nt, _menhir_box_start) _menhir_cell1_prods, _menhir_box_start) _menhir_cell1_prod -> _ -> _ -> _ -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_12 _1 in
      _menhir_run_13 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_06 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_start) _menhir_state -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_nt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | DEF ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LBRACK ->
              _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState07
          | ID _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_0 in
              let _v = _menhir_action_11 _1 in
              _menhir_run_09_spec_07 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  let rec _menhir_run_00 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_start =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACK ->
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState00
      | EOF ->
          let _v = _menhir_action_09 () in
          MenhirBox_start _v
      | _ ->
          _eRR ()
  
end

let start =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_start v = _menhir_run_00 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
